var gAlert = null;

function onLoad()
{
	var arguments = window.arguments[0];
	document.title = arguments.title;
	var desc = document.getElementById("GCAlertDesc");
	var text = document.createTextNode(arguments.desc);
	desc.appendChild(text);
	gAlert = new GCAlert(arguments);
}

function GCAlert(arg)
{
	this.arg = arg;
	this.list = document.getElementById("GCAlertList");
	this.initList(arg.items);
}

GCAlert.prototype.onOK = function()
{
	var cnt = this.list.getRowCount();
	for (var i=0; i<cnt; i++) {
		var item = this.list.getItemAtIndex(i);
		var isChecked = item.getAttribute("checked") == "true";
		this.arg.items[i].checked = isChecked;
	}
	this.arg.notShowAgain = document.getElementById("GCAlertCheck").getAttribute("checked") == "true";
	this.arg.isOK = true;
}

GCAlert.prototype.onCancel = function()
{
	this.arg.isOK = false;
}


GCAlert.prototype.initList = function(items)
{
	if (this.arg.rows) this.list.setAttribute("rows", this.arg.rows);

	var length = items.length;
	for (var i=0; i<length; i++){
		var item = items[i];
		var listitem = this.list.appendItem(item.label);
		listitem.setAttribute("type", "checkbox");
		if (item.checked) listitem.setAttribute("checked", "true");
		listitem.setAttribute("crop", "end");

		if (item.tip) {
			listitem.setAttribute("tooltiptext", item.label);
		}
	}
}

GCAlert.prototype.checkAll = function(check)
{
	var cnt = this.list.getRowCount();
	for (var i=0; i<cnt; i++) {
		var item = this.list.getItemAtIndex(i);
		if (check) item.setAttribute("checked", "true");
		else item.removeAttribute("checked");
	}
}

