var gGCABCard = {
	card: null,
	init: function() {
		this.card = gEditCard.card;
		var me = this;
		if (!this.card) {
			var func = function() {
				me.init();
			};
			dump("Waiting for load\n");
			setTimeout(func, 100);
			return;
		}
		
		var upButton = document.createElement("button");
		upButton.setAttribute("id", "GCUploadButton");
		//upButton.setAttribute("oncommand", "gGCABCard.uploadPhoto()");
		var that = this;
		var upCallback = function() {
			that.uploadPhoto();
		}
		upButton.addEventListener("command", upCallback, false);
		upButton.setAttribute("tooltiptext", "Upload this photo to Google");
		upButton.setAttribute("class", "gcabcard-button");
		
		var delButton = document.createElement("button");
		delButton.setAttribute("id", "GCDeleteButton");
		//delButton.setAttribute("oncommand", "gGCABCard.deletePhoto()");
		var delCallback = function() {
			that.deletePhoto();
		}
		delButton.addEventListener("command", delCallback, false);
		delButton.setAttribute("tooltiptext", "Delete this photo from Google");
		delButton.setAttribute("class", "gcabcard-button");

		var box = document.createElement("hbox");
		box.setAttribute("id", "GCButtonsBox");
		box.appendChild(upButton);
		box.appendChild(delButton);
		var parent = document.getElementById("PhotoFile").parentNode;
		parent.appendChild(box);

   	var button = document.getElementById("GCButtonsBox");
   	var tab = document.getElementById("GCDetailsTabButton");
   	var tabPanel = document.getElementById("GCDetailsTab");
   	var abURI = gEditCard.abURI;
    var abURIArr = abURI ? abURI.split("/") : [];
	  if (abURIArr.length == 4 && abURIArr[0] == "moz-abmdbdirectory:" && abURIArr[3] != "") {
	    abURI = abURIArr[0] + "/" + abURIArr[1] + "/" + abURIArr[2];
	  }
	  var gmAbURI = this.card.getProperty("GmBookUri", null);
    if (!this.card || !this.card.getProperty("GmContactId", null) || !gmAbURI
    		|| gmAbURI != abURI) {
    	button.setAttribute("collapsed", true);
    	tab.setAttribute("collapsed", true);
    	tabPanel.setAttribute("collapsed", true);
    } else {
    	button.removeAttribute("collapsed");
    	var radiogrp = document.getElementById("PhotoType");
    	var changeFunc = function() {
				me.onTypeChange();    		
    	};
    	radiogrp.addEventListener("select", changeFunc, true);
    	this.onTypeChange();
    }
    /*
    if (this.card.getProperty("GmPhotoEtag", null)) {
    	document.getElementById("GCDeleteButton").removeAttribute("disabled");
    } else {
    	document.getElementById("GCDeleteButton").setAttribute("disabled", true);
    }
    */
	},
	
	uploadPhoto: function() {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		var imageURI = document.getElementById("photo").getAttribute("src");
		if (messenger) messenger.gGCContactManager.uploadPhoto(this.card, imageURI);
	},
	
	deletePhoto: function() {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		if (messenger) messenger.gGCContactManager.deletePhoto(this.card);
		updatePhoto("generic");
	},
	
	onTypeChange: function() {
		var radiogrp = document.getElementById("PhotoType");
		var imageURI = document.getElementById("photo").getAttribute("src");
		if (document.getElementById("PhotoType").value == "file" && imageURI.indexOf("file://") == 0) {
			document.getElementById("GCUploadButton").removeAttribute("disabled");
		} else {
			document.getElementById("GCUploadButton").setAttribute("disabled", true);
		}
	},
	
	viewSource: function() {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].
													getService(Components.interfaces.nsIWindowMediator);
		var messenger = windowMediator.getMostRecentWindow("mail:3pane");
		var xmlString = "";
		if (messenger) xmlString = messenger.gGCContactManager.getContactSource(this.card);
		if (!xmlString) xmlString = "<!-- Reload contacts before viewing source. -->"
    //var url = "data:text/plain,"+ encodeURIComponent(xmlString);
		var url = "data:text/xml,"+ encodeURIComponent(xmlString);
    window.openDialog("chrome://global/content/viewSource.xul",
                "_blank", "all,dialog=no", url,
                "charset=UTF-8");
	}
};

window.addEventListener("load", function(){gGCABCard.init();}, false);